<?php

///////////////////////////////////// GPL //////////////////////////////////////
/*

  This file is part of PHP Web Manager.
  Copyright (c) 2010-2011 SimpleGeek. All rights reserved.
  http://www.simplegeek.fr/

  PHP Web Manager is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  PHP Web Manager is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
*/
/////////////////////////////////////////////////////////////////////////////////

/*
	PHP Web Manager: Reloaded
	Fichier: newconfig.win.php
	Dernire modification: 23/05/2010
	Copyright (C) SimpleGeek 2010-2011
*/

#######################
##     SECURITE      ##
#######################

  if(!$logged)
	exit;
	
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr"> 
	<head> 
	
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" /> 
		<meta name="desciption" content="PHP Web Manager: Reloaded - WebFTP" />
		<meta name="keywords" content="client ftp, ftp, php web manager, reloaded, simplegeek, manager, php, web, html, admin, password, filezilla" />
		<meta name="author" content="SimpleGeek" />
		
		<title>PHP Web Manager v<?php echo $version; ?></title>
		
		<link href="<?php echo $PWM_FILES; ?>css/global.css" rel="stylesheet" type="text/css" media="screen" />
		<script type="text/javascript" src="<?php echo $PWM_FILES; ?>global.js"></script>
		
	</head>

	<body>
	
		<table class="head" width="99%" cellpadding="5">
			<tr>
				<td>Panneau de configuration du P.W.M.</td>
				<td align="right"><a href="?type=newconfig&update" class="inp" title="Vrifier la mise  jour">Mise  jour</a></td>
				<td width="1"></td>
			</tr>
		</table>
			<br/><br/><br/>
			
		<div class="newconfig" style="margin:9px; <?php if(!isset($_GET['info'])) echo ("background: url('./PWM_files/images/config.png') right center no-repeat;"); ?>">
			<h3>Bienvenue sur l'assistant de configuration du P.W.M.</h3><br/>

			<?php
				if(isset($_GET['info']))
				{
					echo ('<div id="bind">Depuis la nouvelle version du script, il est possible, en pressant certaines touches prdfinies, d\'interagir avec les fichiers.<br />
							Voici la liste complte:
							<ul>
								<li> Touche A: <i>Selectionner tous les fichiers/dossiers</i></li>
								<li> Touche Z: <i>Dselectionner tous les fichiers/dossiers</i></li>
								<li> Touche E: <i>Inverser la selection</i></li>
								<li> Touche R: <i>Retour  la racine</i></li>
								<br />
								<li> Touche <abbr title="Supprimer">Del</abbr>: <i>Supprimer les fichiers/dossiers selectionns</i></li>
								<li> Touche X: <i>Dplacer les fichiers/dossiers selectionns</i></li>
								<li> Touche C: <i>Copier les fichiers/dossiers selectionns</i></li>
							</ul>
						</div><br />
						<input style="margin:13px;" type="button" onclick="window.location=\'?type=newconfig\'" value="Retour" />
						');
					exit;
				}
			
				elseif(isset($_GET['s']))
				{
					echo '<i id="cf"><font color="green">Enregistr !</font></i><script type="text/javascript">opener.location.reload();setTimeout("document.getElementById(\'cf\').innerHTML = \'Modifier vos paramtre et cliquez sur \"Enregistrer\".\'",2500);</script>';
				}
				
				elseif(isset($_GET['update']))
				{
					$patern_version = '/version = '.$version.'/';
					$open = fopen($update,'r');
					$get = fread($open, 13);
					if(preg_match($patern_version, $get))
					{
						echo '<i id="cf"><font color="green">Votre version est  jour !</font></i><script type="text/javascript">setTimeout("document.getElementById(\'cf\').innerHTML = \'Modifier vos paramtre et cliquez sur \"Enregistrer\".\'",3000);</script>';
					}
					else
					{
						echo '<i id="cf"><font color="red">Il existe une version plus rcente !</font> (<a href="http://www.simplegeek.fr/index?download" title="Nouvelle version" target="_blank">Tlcharger la nouvelle</a>)</i><script type="text/javascript">setTimeout("document.getElementById(\'cf\').innerHTML = \'Modifier vos paramtre et cliquez sur \"Enregistrer\".\'",3000);</script>';
					}
				}
				
				else
				{
					echo '<i id="cf">Modifier vos paramtre et cliquez sur "Enregistrer".</i>';
				}
				
			?>
		
			<br/><br/>

			<form action="?type=newconfig" method="post" name="config" style="margin:11px;">
				Votre nouveau mot de passe : &nbsp;&nbsp;&nbsp;<input id="newpass" type="text" name="newpass" value="" size="42" class="reg"/>
				<br/><br/><br/>

			<table width="100%" cellpadding="5" cellspacing="2">
				<tr>
					<td valign="top">Affichage rapide ? </td>
					<td valign="top" colspan="2"><input type="checkbox" name="fast" value="1" <?php if($fast_display) echo 'checked'; ?>/> (ne pas calculer la taille des dossiers) </td>
				</tr>
				<tr>
					<td valign="top">Activer l'dition Javascript ? </td>
					<td valign="top" colspan="2"><input type="checkbox" name="sh" value="1" <?php if($syntax_highlighting) echo 'checked'; ?>/> (dition  coloration syntaxique en temps rel) </td>
				</tr>
				<tr>
					<td valign="top">Ecraser les fichiers aprs un upload ? </td>
					<td valign="top" colspan="2"><input type="checkbox" name="erase" value="1" <?php if($overwrite_files) echo 'checked'; ?>/> (supprimer les fichiers existants lors d'un upload) </td>
				</tr>
				<tr>
					<td valign="top">Activer l'envoi "Ping" ? </td>
					<td valign="top" colspan="2"><input type="checkbox" name="ping" value="1" <?php if($ping) echo 'checked'; ?>/> (permet de savoir qui est <a href="http://www.simplegeek.fr/index?whois" target="_blank" title="Whois ?">connect</a> sur le PWM)</td>
				</tr>
				<tr>
					<td valign="top">Activer les touches "Bind" ? </td>
					<td valign="top" colspan="2"><input type="checkbox" name="bind" value="1" <?php if($binding) echo 'checked'; ?>/> (<a href="?type=newconfig&info" onclick="hide('bind');">en savoir plus</a>)</td>
				</tr>
				<tr>
					<td valign="top">Tri par dfaut des fichiers</td>
					<td valign="top" width="200">
												  &nbsp;<select name="sort">
													<option value="0"<?php if($default_sort[0] == 0) echo ' selected';?>>Par nom de fichier</option>
													<option value="1"<?php if($default_sort[0] == 1) echo ' selected';?>>Par poids</option>
													<option value="2"<?php if($default_sort[0] == 2) echo ' selected';?>>Par date de modification</option>
													<option value="3"<?php if($default_sort[0] == 3) echo ' selected';?>>Par permissions</option>
													<option value="4"<?php if($default_sort[0] == 4) echo ' selected';?>>Par type de fichier</option>
												  </select>
					</td>
					<td valign="top">
						<input id="sorta" type="radio" value="a" name="sorts"<?php if($default_sort[1] == 'a') echo ' checked';?>/><label for="sorta">Ordre ascendant</label></i><br/>
						<input id="sortd" type="radio" value="d" name="sorts"<?php if($default_sort[1] == 'd') echo ' checked';?>/><label for="sortd">Ordre descendant</label></i>
					</td>
				</tr>
			</table>

			<br/>

				<input type="submit" value="Enregistrer les modifications" />				
			</form>
		</div>
	</body>
</html>