<?php

///////////////////////////////////// GPL //////////////////////////////////////
/*

  This file is part of PHP Web Manager.
  Copyright (c) 2010-2011 SimpleGeek. All rights reserved.
  http://www.simplegeek.fr/

  PHP Web Manager is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  PHP Web Manager is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
*/
/////////////////////////////////////////////////////////////////////////////////

/*
  PHP Web Manager: Reloaded
  Fichier: pwm.php
  Dernire modification: 23/05/2010
  Copyright (C) SimpleGeek 2010-2011
*/
  
#######################
##     SECURITE      ##
#######################

  $logged = TRUE;

#######################
##     INCLUDES      ##
#######################

  include_once ("./PWM_files/inc/config.inc.php");
  include_once ($PWM_FILES."inc/functions.inc.php");
  
#######################
##    COOKIE: SET    ##
#######################

// Si le pass est vide ou NULL, le script ne marche pas
  if(EMPTY($password) || $password == NULL)
  {
  
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr"> 
  <head> 
  
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" /> 
    <meta name="desciption" content="PHP Web Manager: Reloaded - WebFTP" />
    <meta name="keywords" content="client ftp, ftp, php web manager, reloaded, simplegeek, manager, php, web, html, admin, password, filezilla" />
    <meta name="author" content="SimpleGeek" />
    
    <title>PHP Web Manager v<?php echo $version; ?></title>
    
    <link rel="shortcut icon" type="image/x-icon" href="<?php echo $PWM_FILES; ?>images/favicon.ico" /> 
    <link href="<?php echo $PWM_FILES; ?>css/global.css" rel="stylesheet" type="text/css" media="screen" /> 
    
  </head>

  <body>
        <div class="erreur"><br />
          <strong>Bienvenue sur le script de gestion globale PHP Web Manager</strong><br /><br /><br />

          <p style="margin:12px;">
            Si vous voyez ce message, c'est que vous n'avez pas modifi le fichier de configuration<br />et ne pouvez donc pas utiliser le <abbr title="PHP Web Manager">PWM</abbr>: Reloaded<br /><br />
            
          Pour pouvoir utiliser ce script, veuillez diter la ligne <i>password</i> dans le fichier <i>config.inc.php</i><br />via votre diteur syntaxique et de r-uploader le fichier sur votre espace d'hbergement.
          
            <br /><br /><br />
            
            Ce software est distribu sous licence GPL.<br />
            Vous pouvez le modifier  votre guise  condition de ne pas vous l'approprier ;)<br />
            <br />
            Copyright  PHP Web Manager: Reloaded project and its contributors. All rights reserved.<br />

          </p>

        </div>

        <table class="foot" width="99%" cellpadding="10">
          <tr>
            <td width="70%" align="left">Veuillez modifier le mot de passe dans le fichier <i>config.inc.php</i></td>
          </tr>
        </table>

      </center>
    </form>

  </body>
  
</html>

<?php

  }

// Si le password est le bon
  elseif(isset($_POST['password']) && $_POST['password'] == $password)
  {
    $timestamp_expire = time() + 3600*24*7; // 7 jours
    setcookie('pwm', md5($_POST['password']), $timestamp_expire);
    redirect('?');
  }

// Si il existe le cookie du password et gale  celui de la config
  elseif(isset($_COOKIE['pwm']) && ($_COOKIE['pwm'] == md5($password)))
  {
    include_once ($PWM_FILES."inc/content.inc.php");
	
	// On envoi le ping si il est activ
	if($ping) { ?>
	
	<script type="text/javascript">
			// Ping le PWM
			function ping() {

			var xhr = null;

			if(window.XMLHttpRequest) xhr = new XMLHttpRequest();
			else if(window.ActiveXObject) xhr = new ActiveXObject("Microsoft.XMLHTTP");

			xhr.open("GET", "?type=whois", true);
			xhr.send(null);
			xhr.onreadystatechange = function()
				{
				if(xhr.readyState == 4) return true;
				}
			}

			setInterval("ping();", 30000);
			ping();
		</script>
			
<?php }
  }
  
  else
  {
  
?>


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr"> 
  <head> 
  
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" /> 
    <meta name="desciption" content="PHP Web Manager: Reloaded - WebFTP" />
    <meta name="keywords" content="client ftp, ftp, php web manager, reloaded, simplegeek, manager, php, web, html, admin, password, filezilla" />
    <meta name="author" content="SimpleGeek" />
    
    <title>PHP Web Manager v<?php echo $version; ?></title>
    
    <link rel="shortcut icon" type="image/x-icon" href="<?php echo $PWM_FILES; ?>images/favicon.ico" /> 
    <link href="<?php echo $PWM_FILES; ?>css/global.css" rel="stylesheet" type="text/css" media="screen" /> 
    
  </head>

  <body>
  
    <form action="?" method="post" name="login">
      <center>
        <table class="head" width="99%" cellpadding="2">
          <tr>
            <td width="70%" align="left">&nbsp;Connexion au FTP : &nbsp;<input type="password" name="password" size="26" class="up" value="yourPassword" onfocus="if(this.value == 'yourPassword'){this.value = '';}" onblur="if(this.value == ''){this.value = 'yourPassword';}" />&nbsp;<input type="submit" value="Connect !" class="go"/></td>
            <td width="29%" align="right"><i># by <?php echo $author; ?>&nbsp;~</i></td>
            <td width="01%" align="left">&nbsp;</td>
          </tr>
        </table>

        <div class="global"><br />
          <strong>Bienvenue sur le script de gestion globale PHP Web Manager, pour commencer, veuillez vous logger.</strong><br /><br /><br />

          <p style="margin:12px;">
            Voici une liste exhaustive des fonctionalits du <abbr title="PHP Web Manager">PWM</abbr>: Reloaded<br /><br />
            
            <ul class="listing">
              <li>Listing rapide des fichiers et des dossiers</li>
              <li>Edition en ligne (coloration syntaxique en temps rel via <a href="http://marijn.haverbeke.nl/codemirror/" target="_blank" alt="Site officiel de CodeMirror">CodeMirror</a>)</li>
              <li>Download et Upload</li>
              <li>Player MP3/MWA en HTML5</li>
              <li>Cration de nouveaux fichiers/dossiers</li>
              <li>Informations sur la configuration PHP (ainsi que du php.ini)</li>
              <li>Console de configuration simplifie pour l'utilisateur lambda</li>
              <li>Recherches personnalises dans l'ensemble de vos fichiers</li>
              <li>Edition des permissions CHMOD</li>
              <li>Zip et extraction des fichiers en ligne</li>
            </ul>

            <br /><br />
            
            Ce software est distribu sous licence GPL.<br />
            Vous pouvez le modifier  votre guise  condition de ne pas vous l'approprier ;)<br />
            <br />
            Copyright  PHP Web Manager: Reloaded project and its contributors. All rights reserved.<br />

          </p>

        </div>

        <table class="foot" width="99%" cellpadding="10">
          <tr>
            <td width="70%" align="left">Veuillez entrer le mot de passe pour <?php echo $HOST; ?></td>
          </tr>
        </table>

      </center>
    </form>

  </body>
  
</html>

<?php

  }
  
?>